com.io7m.r2.core.debug

## Class R2DebugVisualizerRendererParameters

- java.lang.Object
- - com.io7m.r2.core.debug.R2DebugVisualizerRendererParameters

- All Implemented Interfaces:
    R2DebugVisualizerRendererParametersType

      @Generated(value={"Immutables.generator","R2DebugVisualizerRendererParametersType"})
      public final class R2DebugVisualizerRendererParameters
      extends Object
      implements R2DebugVisualizerRendererParametersType

  Parameters for debug-visualizing renderers.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2DebugVisualizerRendererParameters.Builder` Builds instances of type `R2DebugVisualizerRendererParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static R2DebugVisualizerRendererParameters.Builder` | `builder()` Creates a builder for `R2DebugVisualizerRendererParameters`.
    `static R2DebugVisualizerRendererParameters` | `copyOf(R2DebugVisualizerRendererParametersType instance)` Creates an immutable copy of a `R2DebugVisualizerRendererParametersType` value.
    `R2DebugCubeUsableType` | `debugCube()`
    `R2DebugInstancesType` | `debugInstances()`
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2DebugVisualizerRendererParameters` that have equal attribute values.
    `com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>` | `geometryDefaultColor()`
    `it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>>` | `geometryGroupColors()` The mapping from groups to colors.
    `int` | `hashCode()` Computes a hash code from attributes: `unitSphere`, `debugCube`, `opaqueInstances`, `lights`, `debugInstances`, `showOpaqueInstances`, `showLights`, `geometryGroupColors`, `geometryDefaultColor`.
    `R2SceneLightsType` | `lights()`
    `static R2DebugVisualizerRendererParameters` | `of(R2UnitSphereUsableType unitSphere, R2DebugCubeUsableType debugCube, R2SceneOpaquesReadableType opaqueInstances, R2SceneLightsType lights, R2DebugInstancesType debugInstances, boolean showOpaqueInstances, boolean showLights, it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>> geometryGroupColors, com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> geometryDefaultColor)` Construct a new immutable `R2DebugVisualizerRendererParameters` instance.
    `R2SceneOpaquesReadableType` | `opaqueInstances()`
    `boolean` | `showLights()`
    `boolean` | `showOpaqueInstances()`
    `String` | `toString()` Prints the immutable value `R2DebugVisualizerRendererParameters` with attribute values.
    `R2UnitSphereUsableType` | `unitSphere()`
    `R2DebugVisualizerRendererParameters` | `withDebugCube(R2DebugCubeUsableType value)` Copy the current immutable object by setting a value for the `debugCube` attribute.
    `R2DebugVisualizerRendererParameters` | `withDebugInstances(R2DebugInstancesType value)` Copy the current immutable object by setting a value for the `debugInstances` attribute.
    `R2DebugVisualizerRendererParameters` | `withGeometryDefaultColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)` Copy the current immutable object by setting a value for the `geometryDefaultColor` attribute.
    `R2DebugVisualizerRendererParameters` | `withGeometryGroupColors(it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>> value)` Copy the current immutable object by setting a value for the `geometryGroupColors` attribute.
    `R2DebugVisualizerRendererParameters` | `withLights(R2SceneLightsType value)` Copy the current immutable object by setting a value for the `lights` attribute.
    `R2DebugVisualizerRendererParameters` | `withOpaqueInstances(R2SceneOpaquesReadableType value)` Copy the current immutable object by setting a value for the `opaqueInstances` attribute.
    `R2DebugVisualizerRendererParameters` | `withShowLights(boolean value)` Copy the current immutable object by setting a value for the `showLights` attribute.
    `R2DebugVisualizerRendererParameters` | `withShowOpaqueInstances(boolean value)` Copy the current immutable object by setting a value for the `showOpaqueInstances` attribute.
    `R2DebugVisualizerRendererParameters` | `withUnitSphere(R2UnitSphereUsableType value)` Copy the current immutable object by setting a value for the `unitSphere` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### unitSphere

          public R2UnitSphereUsableType unitSphere()

      Specified by:
        `unitSphere` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        A unit sphere used to render various pieces of debug geometry

    - #### debugCube

          public R2DebugCubeUsableType debugCube()

      Specified by:
        `debugCube` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        A debug cube used to render various pieces of debug geometry

    - #### opaqueInstances

          public R2SceneOpaquesReadableType opaqueInstances()

      Specified by:
        `opaqueInstances` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        The opaque instances in the scene.

    - #### lights

          public R2SceneLightsType lights()

      Specified by:
        `lights` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        The lights in the scene.

    - #### debugInstances

          public R2DebugInstancesType debugInstances()

      Specified by:
        `debugInstances` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        The extra debugging instances

    - #### showOpaqueInstances

          public boolean showOpaqueInstances()

      Specified by:
        `showOpaqueInstances` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        `true` iff opaque instances should be rendered

    - #### showLights

          public boolean showLights()

      Specified by:
        `showLights` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        `true` iff lights should be rendered

    - #### geometryGroupColors

          public it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>> geometryGroupColors()

      The mapping from groups to colors. Each instance will be rendered a specific color based on the group to which it belongs. If no mapping exists from the group number to a color, the default color will be used instead.
      Specified by:
        `geometryGroupColors` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        A mapping from groups to colors
      See Also:
        `geometryDefaultColor()`

    - #### geometryDefaultColor

          public com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> geometryDefaultColor()

      Specified by:
        `geometryDefaultColor` in interface `R2DebugVisualizerRendererParametersType`
      Returns:
        The default color with which to render instances, if no specific color has been set
      See Also:
        `geometryGroupColors()`

    - #### withUnitSphere

          public final R2DebugVisualizerRendererParameters withUnitSphere(R2UnitSphereUsableType value)

      Copy the current immutable object by setting a value for the `unitSphere` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for unitSphere
      Returns:
        A modified copy of the `this` object

    - #### withDebugCube

          public final R2DebugVisualizerRendererParameters withDebugCube(R2DebugCubeUsableType value)

      Copy the current immutable object by setting a value for the `debugCube` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for debugCube
      Returns:
        A modified copy of the `this` object

    - #### withOpaqueInstances

          public final R2DebugVisualizerRendererParameters withOpaqueInstances(R2SceneOpaquesReadableType value)

      Copy the current immutable object by setting a value for the `opaqueInstances` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for opaqueInstances
      Returns:
        A modified copy of the `this` object

    - #### withLights

          public final R2DebugVisualizerRendererParameters withLights(R2SceneLightsType value)

      Copy the current immutable object by setting a value for the `lights` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for lights
      Returns:
        A modified copy of the `this` object

    - #### withDebugInstances

          public final R2DebugVisualizerRendererParameters withDebugInstances(R2DebugInstancesType value)

      Copy the current immutable object by setting a value for the `debugInstances` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for debugInstances
      Returns:
        A modified copy of the `this` object

    - #### withShowOpaqueInstances

          public final R2DebugVisualizerRendererParameters withShowOpaqueInstances(boolean value)

      Copy the current immutable object by setting a value for the `showOpaqueInstances` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for showOpaqueInstances
      Returns:
        A modified copy of the `this` object

    - #### withShowLights

          public final R2DebugVisualizerRendererParameters withShowLights(boolean value)

      Copy the current immutable object by setting a value for the `showLights` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for showLights
      Returns:
        A modified copy of the `this` object

    - #### withGeometryGroupColors

          public final R2DebugVisualizerRendererParameters withGeometryGroupColors(it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>> value)

      Copy the current immutable object by setting a value for the `geometryGroupColors` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for geometryGroupColors
      Returns:
        A modified copy of the `this` object

    - #### withGeometryDefaultColor

          public final R2DebugVisualizerRendererParameters withGeometryDefaultColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)

      Copy the current immutable object by setting a value for the `geometryDefaultColor` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for geometryDefaultColor
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2DebugVisualizerRendererParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `unitSphere`, `debugCube`, `opaqueInstances`, `lights`, `debugInstances`, `showOpaqueInstances`, `showLights`, `geometryGroupColors`, `geometryDefaultColor`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2DebugVisualizerRendererParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2DebugVisualizerRendererParameters of(R2UnitSphereUsableType unitSphere,
                                                               R2DebugCubeUsableType debugCube,
                                                               R2SceneOpaquesReadableType opaqueInstances,
                                                               R2SceneLightsType lights,
                                                               R2DebugInstancesType debugInstances,
                                                               boolean showOpaqueInstances,
                                                               boolean showLights,
                                                               it.unimi.dsi.fastutil.ints.Int2ReferenceMap<com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>> geometryGroupColors,
                                                               com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> geometryDefaultColor)

      Construct a new immutable `R2DebugVisualizerRendererParameters` instance.
      Parameters:
        `unitSphere` - The value for the `unitSphere` attribute
        `debugCube` - The value for the `debugCube` attribute
        `opaqueInstances` - The value for the `opaqueInstances` attribute
        `lights` - The value for the `lights` attribute
        `debugInstances` - The value for the `debugInstances` attribute
        `showOpaqueInstances` - The value for the `showOpaqueInstances` attribute
        `showLights` - The value for the `showLights` attribute
        `geometryGroupColors` - The value for the `geometryGroupColors` attribute
        `geometryDefaultColor` - The value for the `geometryDefaultColor` attribute
      Returns:
        An immutable R2DebugVisualizerRendererParameters instance

    - #### copyOf

          public static R2DebugVisualizerRendererParameters copyOf(R2DebugVisualizerRendererParametersType instance)

      Creates an immutable copy of a `R2DebugVisualizerRendererParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2DebugVisualizerRendererParameters instance

    - #### builder

          public static R2DebugVisualizerRendererParameters.Builder builder()

      Creates a builder for `R2DebugVisualizerRendererParameters`.
      Returns:
        A new R2DebugVisualizerRendererParameters builder

Copyright © 2017 <code@io7m.com> http://io7m.com